
/** This class performs a Breath first search on a Graph
 */
public class BFS {
    
    private Graph g ;
    private Queue q ;
    
    /** Create a new BFS object
     * @param g the graph to performs the search on
     */
    public BFS(Graph g) {
        this.g= g;
    }
    
    // this resets the parents, depths and colors
    /** reset the properties that BFS depends on. this DOESN'T need to be called everytime search is called
     */
    public void reset() {
        for( int i =0 ; i < g.getNVertices() ; i++) {
            g.getVertex(i).setParent(null) ;
            g.getVertex(i).setDepth(-1) ;
            g.getVertex(i).setColor('W') ;
        }
    }
    
    /** perform a BFS search from source Vertex v
     * @param v the node to being the search at
     */
    public void search(Vertex v) {
        
        reset() ;
        
        Queue q = new Queue() ;
        Vertex v1 ;
        
        q.push(v) ;
        v.setDepth(0) ;
        
        while( !q.isEmpty() ) {
            v1 = (Vertex) q.pop() ;
            int depth = v1.getDepth() ;
            depth++ ;
            
            // get edges here
            AdjacencyList l = g.getAdjList(v1) ;
            
            for (int i = 0; i< l.length() ; i++ ) {
                if (l.getEdge(i).getRes() != 0 ) {
                    Vertex c = l.getVertex(i) ;
                    if(c.getColor() == 'W') {
                        c.setParent(v1) ;
                        c.setDepth(depth) ;
                        c.setColor('G');
                        q.push(c) ;
                    }
                }
            }
            v1.setColor('B') ;
        }
    }
    
} //end class
