
/** Simple implementation of a queue. Use push to add objects, pop to return the object at the front of
 * the queue.
 */
public class Queue {
    
    private Item head ;
    private Item tail ;
    
    /** create a new queue
     */
    public Queue() {
        
        
    }
    
    /** checks if the queue is empty
     * @return true if the queue is empty, false otherwise
     */
    public boolean isEmpty() {
        return (head==null) ;
        
    }
    
    /** Push an object onto the end of this Queue
     * @param o the object to be added
     */
    public void push(Object o) {
        Item i = new Item(o) ;
        i.next = null ;
        
        if(head == null) {
            head = i ;
            tail = i ;
        } else {
            tail.next = i ;
            tail = i ;
        }
    }
    
    /** Take the object off the front of the queue
     * @return the object at the front of the queue, or null if empty
     */
    public Object pop() {
        
        if(head == null) return null ;
        
        Object o = head.o ;
        
        head = head.next ;
        
        if(head==null) tail = null ;
        
        return o ;
    }
    
    
    
    /** This is a inner class, used be the Queue class to represent an item in the queue
     */
    private class Item {
        
        /** the object in the queue
         */
        public Object o;
        /** a pointer to the next item in the queue
         */
        public Item next ;
        
        /** Creates a new QueueItem
         * @param o the object to wrap
         */
        public Item( Object o) {
            this.o = o ;
        }
    }
    
}
